library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity FSM is
    Port (
            clk :       in std_logic;
            reset :     in std_logic;
            A :         in std_logic;
            B :         in std_logic;
            LED :       out std_logic );
end FSM;

architecture Behavioral of FSM is

    type state_t is (S_RST, S_A, S_B, S_BB, S_AA, S_AB, S_ABB, S_AAB, S_AABB); 
    signal state : state_t;
    
    
 begin   
---Implementacion de FSM explicita-- (ecuaciones de estado)
    process(clk,reset) --boton start
        begin
            if (reset = '1') then
                state <= S_RST;
            elsif (clk'event and clk ='1') then 
                case state is
            
                    when S_RST =>
                        if (A = '0' and B= '1') then
                            state <= S_B; 
                        elsif (A='1' and B='0') then
                            state<= S_A;
                        end if;
            
                    when S_A =>
                        if (A = '0' and B= '1') then 
                            state <= S_AB;
                        elsif (A='1' and B='0') then 
                            state<= S_AA;
                        end if;
            
                    when S_B =>
                        if (A = '0' and B= '1') then 
                            state <= S_BB;
                        elsif (A='1' and B='0') then 
                            state<= S_AB;
                        end if;
            
                    when S_AA =>
                        if (A = '0' and B= '1') then
                            state <= S_AAB;
                        end if;
            
                    when S_BB =>
                        if (A = '1' and B= '0') then 
                            state <= S_ABB;
                        end if; 
                    
                    when S_AB =>
                        if (A = '0' and B= '1') then 
                            state <= S_ABB;
                        elsif (A='1' and B='0') then
                            state<= S_AAB;
                        end if;
                        
                    when S_AAB =>
                        if (A = '0' and B= '1') then 
                            state <= S_AABB;
                        end if; 
                        
                    when S_ABB =>
                        if (A = '1' and B= '0') then 
                            state <= S_AABB;
                        end if; 
                        
                    when S_AABB =>
                    
                end case; 
            end if;
    end process;


--Generamos la salida
LED <= '1' when (state=S_AABB) else '0';


end Behavioral;
